<?php //$Id: backuplib.php,v 1.6.6.1 2007/04/22 22:05:19 stronk7 Exp $
    //This php script contains all the stuff to backup/restore
    //fmsmeeting mods

    //This is the "graphical" structure of the fmsmeeting mod:
    //
    //                     fmsmeeting                                      
    //                 (CL,pk->id,files)
    //
    // Meaning: pk->primary key field of the table
    //          fk->foreign key to link with parent
    //          nt->nested field (recursive data)
    //          CL->course level info
    //          UL->user level info
    //          files->table may have files)
    //
    //-----------------------------------------------------------

    //This function executes all the backup procedure about this mod
    function fmsmeeting_backup_mods($bf,$preferences) {
        global $CFG;

        $status = true; 

        ////Iterate over fmsmeeting table
        $fmsmeetings = get_records ("fmsmeeting","course",$preferences->backup_course,"id");
        if ($fmsmeetings) {
            foreach ($fmsmeetings as $fmsmeeting) {
                if (backup_mod_selected($preferences,'fmsmeeting',$fmsmeeting->id)) {
                    $status = fmsmeeting_backup_one_mod($bf,$preferences,$fmsmeeting);
                }
            }
        }
        return $status;
    }
   
    function fmsmeeting_backup_one_mod($bf,$preferences,$fmsmeeting) {

        global $CFG;
    
        if (is_numeric($fmsmeeting)) {
            $fmsmeeting = get_record('fmsmeeting','id',$fmsmeeting);
        }
    
        $status = true;

        //Start mod
        fwrite ($bf,start_tag("MOD",3,true));
        //Print assignment data
        fwrite ($bf,full_tag("ID",4,false,$fmsmeeting->id));
        fwrite ($bf,full_tag("MODTYPE",4,false,"fmsmeeting"));
        fwrite ($bf,full_tag("NAME",4,false,$fmsmeeting->name));
        fwrite ($bf,full_tag("SUMMARY",4,false,$fmsmeeting->summary));
        fwrite ($bf,full_tag("TYPE",4,false,$fmsmeeting->type));
        fwrite ($bf,full_tag("ALLTEXT",4,false,$fmsmeeting->alltext));
        fwrite ($bf,full_tag("TIMEMODIFIED",4,false,$fmsmeeting->timemodified));
        //End mod
        $status = fwrite ($bf,end_tag("MOD",3,true));

        // backup files for this fmsmeeting.
        $status = fmsmeeting_backup_files($bf,$preferences,$fmsmeeting);

        return $status;
    }

   ////Return an array of info (name,value)
   function fmsmeeting_check_backup_mods($course,$user_data=false,$backup_unique_code,$instances=null) {
       if (!empty($instances) && is_array($instances) && count($instances)) {
           $info = array();
           foreach ($instances as $id => $instance) {
               $info += fmsmeeting_check_backup_mods_instances($instance,$backup_unique_code);
           }
           return $info;
       }
       //First the course data
       $info[0][0] = get_string("modulenameplural","fmsmeeting");
       if ($ids = fmsmeeting_ids ($course)) {
           $info[0][1] = count($ids);
       } else {
           $info[0][1] = 0;
       }
       
       return $info;
   }

   ////Return an array of info (name,value)
   function fmsmeeting_check_backup_mods_instances($instance,$backup_unique_code) {
        //First the course data
        $info[$instance->id.'0'][0] = '<b>'.$instance->name.'</b>';
        $info[$instance->id.'0'][1] = '';

        return $info;
    }

    //Return a content encoded to support interactivities linking. Every module
    //should have its own. They are called automatically from the backup procedure.
    function fmsmeeting_encode_content_links ($content,$preferences) {

        global $CFG;

        $base = preg_quote($CFG->wwwroot,"/");

        //Link to the list of fmsmeetings
        $buscar="/(".$base."\/mod\/fmsmeeting\/index.php\?id\=)([0-9]+)/";
        $result= preg_replace($buscar,'$@FMSMEETINGINDEX*$2@$',$content);

        //Link to fmsmeeting view by moduleid
        $buscar="/(".$base."\/mod\/fmsmeeting\/view.php\?id\=)([0-9]+)/";
        $result= preg_replace($buscar,'$@FMSMEETINGVIEWBYID*$2@$',$result);

        //Link to fmsmeeting view by fmsmeetingid
        $buscar="/(".$base."\/mod\/fmsmeeting\/view.php\?r\=)([0-9]+)/";
        $result= preg_replace($buscar,'$@FMSMEETINGVIEWBYR*$2@$',$result);

        return $result;
    }

    // INTERNAL FUNCTIONS. BASED IN THE MOD STRUCTURE

    //Returns an array of fmsmeetings id
    function fmsmeeting_ids ($course) {

        global $CFG;

        return get_records_sql ("SELECT a.id, a.course
                                 FROM {$CFG->prefix}fmsmeeting a
                                 WHERE a.course = '$course'");
    }
   
    function fmsmeeting_backup_files($bf,$preferences,$fmsmeeting) {
        global $CFG;
        $status = true;

        // now, just in case we check moddata ( going forwards, fmsmeetings should use this )
        $status = $status && check_and_create_moddata_dir($preferences->backup_unique_code);
        $status = $status && check_dir_exists($CFG->dataroot."/temp/backup/".$preferences->backup_unique_code."/".$CFG->moddata."/fmsmeeting",true);
        
        if ($status) {
            //Only if it exists !! Thanks to Daniel Miksik.
            if (is_dir($CFG->dataroot."/".$preferences->backup_course."/".$CFG->moddata."/fmsmeeting")) {
                $status = backup_copy_file($CFG->dataroot."/".$preferences->backup_course."/".$CFG->moddata."/fmsmeeting",
                                           $CFG->dataroot."/temp/backup/".$preferences->backup_unique_code."/moddata/fmsmeeting");
            }
        }

        return $status;
    }

?>
