<?php

class fmsmeeting_slideshow extends fmsmeeting_component {
 
    var $name = 'slideshow';

    var $attributes = array('slideshow_coop', 'slideshow_foreground');

    function mod_form(&$mform) {
        // Slide Selector
        $slidegrp = array();
        $slidelist = &$mform->createElement('select', 'slidelist', null, array('0' => get_string('none')), 'mutiple="multiple" size="5"');
        $slidegrp[] = $slidelist;

        $slidegrp[] = &$mform->createElement('static', '', '' ,'<br />');

        $removebutton = &$mform->createElement('button', 'removeslide', get_string('slideshow_removefile','fmsmeeting'));
        $buttonattributes = array('onclick'=>"var selectoptions = document.getElementById('id_slidelist').options.length; for (var i = selectoptions-1; i >=0 ; i--) { if ((document.getElementById('id_slidelist').options[i].selected) && (document.getElementById('id_slidelist').options[i].value != 0)) { document.getElementById('id_slidelist').options[i] = null; } } if (document.getElementById('id_slidelist').options.length == 0) { document.getElementById('id_slidelist').options[0] = new Option(\"".get_string('none')."\", 0); } var slides = new Array(); for (var i=0; i < selectoptions-1; i++) { if (document.getElementById('id_slidelist').options[i].value != 0) { slides[i] = document.getElementById('id_slidelist').options[i].value; } } document.getElementsByName('slides')[0].value = slides.join(',');");
        $removebutton->updateAttributes($buttonattributes);
        $slidegrp[] = $removebutton;
    
        $addbutton = &$mform->createElement('button', 'addslide', get_string('slideshow_addfile','fmsmeeting'));
        $buttonattributes = array('onclick'=>"lastoption = 0; if (document.getElementById('id_slideshowlocation_value').value!='') { if (document.getElementById('id_slidelist').options[0].value != 0) { lastoption = document.getElementById('id_slidelist').length; document.getElementById('id_slidelist').options[lastoption] = new Option(); } document.getElementById('id_slidelist').options[lastoption].value = document.getElementById('id_slideshowlocation_value').value; document.getElementById('id_slidelist').options[lastoption].text = document.getElementById('id_slideshowlocation_value').value; document.getElementById('id_slideshowlocation_value').value = ''; } var slides = new Array(); for (var i=0; i < lastoption+1; i++) { if (document.getElementById('id_slidelist').options[i].value != 0) { slides[i] = document.getElementById('id_slidelist').options[i].value; } } document.getElementsByName('slides')[0].value = slides.join(',');");
        $addbutton->updateAttributes($buttonattributes);
        $slidegrp[] = $addbutton;
    
        $mform->addGroup($slidegrp, 'slidegrp', get_string('slideshow_slides','fmsmeeting'), ' ', false);
        //$mform->disabledIf('slidegrp', 'preset', 'eq', 'video');

        $mform->addElement('hidden','slides');
    
        $mform->addElement('choosecoursefile','slideshowlocation', get_string('slideshow_location','fmsmeeting'));
        $mform->disabledIf('slideshowlocation', 'preset', 'eq', 'video');
         
        $slidescript = '<script type="text/javascript" defer="defer">
//<![CDATA[

if (document.getElementsByName("slides")[0].value != "") {
    var slides = document.getElementsByName("slides")[0].value.split(",");
    for (i=0;i<slides.length;i++) {
        lastoption = 0;
        if (document.getElementById("id_slidelist").options[0].value != 0) {
            lastoption = document.getElementById("id_slidelist").length;
            document.getElementById("id_slidelist").options[lastoption] = new Option();
        }
        document.getElementById("id_slidelist").options[lastoption].value = slides[i];
        document.getElementById("id_slidelist").options[lastoption].text = slides[i];
   } 
}

//]]>
</script>';
   
        $mform->addElement('static', '', '' ,$slidescript);
    }

    function _preprocess(&$default_values, $fmsmeetingxml) {
        global $CFG;

        $component = 'presentation';

        if (isset($fmsmeetingxml['connection']['#'][$component])) {
            if (!empty($fmsmeetingxml['connection']['#'][$component][0]['@'])) {
                $default_values['slideshow'] = 1;
                $attributes = $fmsmeetingxml['connection']['#'][$component][0]['@'];
                foreach ($attributes as $attribute => $value) {
                    if ($value == 'true') {
                        $default_values['slideshow_'.$attribute] = 1;
                    }
                }
            }
            $attributes = $fmsmeetingxml['connection']['#'][$component];
            foreach ($attributes[0]['#']['slide'] as $slide) {
                if (isset($slide['@'])) {
                    $element = $slide['@']['src'];
                    $filepath = $CFG->wwwroot.'/file.php'.(($CFG->slasharguments==1)?'/':'?file=/').$default_values['course'].'/';
                    if (substr($slide['@']['src'],0,strlen($filepath)) == $filepath) {
                        $element = substr($slide['@']['src'],strlen($filepath));
                    } elseif (substr($slide['@']['src'],0,strlen($_SERVER['HTTP_HOST'])) == $_SERVER['HTTP_HOST']) {
                        $element = substr($slide['@']['src'],strlen($_SERVER['HTTP_HOST']));
                    }
                    $slides[$element] = $element;
                }
            }
            $default_values['slides'] = join(',', $slides);
        }
    }
    
    function _postprocess(&$fmsmeeting) {
        global $CFG;
   
        if (isset($fmsmeeting->slideshow)) {
            if (isset($fmsmeeting->slides)) {
                if (!empty($fmsmeeting->slides)) {
                    $fmsmeeting->alltext .= "\t<presentation";
                    if (isset($fmsmeeting->slideshow_coop)) {
                        $fmsmeeting->alltext .= ' coop="true"';
                        unset($fmsmeeting->slideshow_coop);
                    } else {
                        $fmsmeeting->alltext .= ' coop="false"';
                    }
                    if (isset($fmsmeeting->slideshow_foreground)) {
                        $fmsmeeting->alltext .= ' foreground="true"';
                        unset($fmsmeeting->slideshow_foreground);
                    } else {
                        $fmsmeeting->alltext .= ' foreground="false"';
                    }
                    $fmsmeeting->alltext .= ">\n";
                    if (isset($fmsmeeting->slides) && !empty($fmsmeeting->slides)) {
                        $slides = explode(',',$fmsmeeting->slides);
                        unset($fmsmeeting->slides);

                        $openofficetypes = array('123','bmp','cgm','csv','dbf','dif','doc','dot','dxf','emf','eps','htm',
                                                 'html','hwp','jtd','jtt','met','mml','odb','odf','odg','odm','odp','ods',
                                                 'odt','otg','oth','otp','ots','ott','pbm','pcd','pct','pcx','pdb','pgm',
                                                 'pot','ppm','pps','ppt','psd','psw','pxl','ras','rtf','sda','sdc','sdd',
                                                 'sdp','sdw','sgf','sgl','sgv','slk','smf','stc','std','sti','stw','svm',
                                                 'sxc','sxd','sxg','sxi','sxm','sxw','tga','tiff','txt','vor','wk1','wks',
                                                 'wmf','wpd','wps','xbm','xls','xlt','xlw','xml','xpm');
                        $swftoolstypes = array('gif','pdf','png');
                        $flashtypes = array('swf','jpeg','jpg','jpe','jfif','jif','jfi');

                        $connector = $CFG->slasharguments?'':'?file=';
                        foreach ($slides as $slide) {
                            $flashslide = '';
                            $slide = trim($slide);
                            if (eregi('\.([a-z0-9]+)$', $slide, $match)) {
                                $extension = strtolower($match[1]);
                                if (in_array($extension,$flashtypes)) {
                                    $flashslide = $CFG->wwwroot.'/file.php'.$connector.'/'.$fmsmeeting->course.'/'.$slide;
                                }
                                if (empty($flashslide) && !empty($CFG->fmsmeeting_openoffice) && in_array($extension,$openofficetypes)) {
                                    // I must use OpenOffice
                                }
                                if (empty($flashslide) && in_array($extension,$swftoolstypes)) {
                                    // I can use SWFTools
                                    switch ($extension) {
                                        case 'gif':
                                            if (!empty($CFG->fmsmeeting_gif2swf) && file_exists($CFG->fmsmeeting_gif2swf)) {
                                                $outputfile = '/'.$fmsmeeting->course.'/'.$CFG->moddata.'/fmsmeeting/'.substr($slide,0,-4).'.swf';
                                                $inputfile = '/'.$fmsmeeting->course.'/'.$slide;
                                                if ($scormdir = make_upload_directory(dirname($outputfile))) {
                                                    if (file_exists($CFG->dataroot.$inputfile)) {
                                                        if (file_exists($CFG->dataroot.$outputfile)) {
                                                            if (filectime($CFG->dataroot.$outputfile) <= filectime($CFG->dataroot.$inputfile)) {
                                                                exec(escapeshellcmd($CFG->fmsmeeting_gif2swf).' -v 0 -o '.escapeshellarg($CFG->dataroot.$outputfile).' '.escapeshellarg($CFG->dataroot.$inputfile));
                                                            }
                                                        } else {
                                                            exec(escapeshellcmd($CFG->fmsmeeting_gif2swf).' -v 0 -o '.escapeshellarg($CFG->dataroot.$outputfile).' '.escapeshellarg($CFG->dataroot.$inputfile));
                                                        }
                                                        if (file_exists($CFG->dataroot.$outputfile)) {
                                                            $flashslide = $CFG->wwwroot.'/file.php'.$connector.$outputfile;
                                                        }
                                                    }
                                                }
                                            }
                                        break;
                                        case 'png':
                                            if (!empty($CFG->fmsmeeting_png2swf) && file_exists($CFG->fmsmeeting_png2swf)) {
                                                $outputfile = '/'.$fmsmeeting->course.'/'.$CFG->moddata.'/fmsmeeting/'.substr($slide,0,-4).'.swf';
                                                $inputfile = '/'.$fmsmeeting->course.'/'.$slide;
                                                if ($scormdir = make_upload_directory(dirname($outputfile))) {
                                                    if (file_exists($CFG->dataroot.$inputfile)) {
                                                        if (file_exists($CFG->dataroot.$outputfile)) {
                                                            if (filectime($CFG->dataroot.$outputfile) <= filectime($CFG->dataroot.$inputfile)) {
                                                                exec(escapeshellcmd($CFG->fmsmeeting_png2swf).' -v 0 -o '.escapeshellarg($CFG->dataroot.$outputfile).' '.escapeshellarg($CFG->dataroot.$inputfile));
                                                            }
                                                        } else {
                                                            exec(escapeshellcmd($CFG->fmsmeeting_png2swf).' -v 0 -o '.escapeshellarg($CFG->dataroot.$outputfile).' '.escapeshellarg($CFG->dataroot.$inputfile));
                                                        }
                                                        if (file_exists($CFG->dataroot.$outputfile)) {
                                                            $flashslide = $CFG->wwwroot.'/file.php'.$connector.$outputfile;
                                                        }
                                                    }
                                                }
                                            }
                                        break;
                                        case 'pdf':
                                            if (!empty($CFG->fmsmeeting_pdf2swf) && file_exists($CFG->fmsmeeting_pdf2swf)) {
                                                $outputfile = '/'.$fmsmeeting->course.'/'.$CFG->moddata.'/fmsmeeting/'.substr($slide,0,-4).'.swf';
                                                $inputfile = '/'.$fmsmeeting->course.'/'.$slide;
                                                if ($scormdir = make_upload_directory(dirname($outputfile))) {
                                                    if (file_exists($CFG->dataroot.$inputfile)) {
                                                        if (file_exists($CFG->dataroot.$outputfile)) {
                                                            if (filectime($CFG->dataroot.$outputfile) <= filectime($CFG->dataroot.$inputfile)) {
                                                                exec(escapeshellcmd($CFG->fmsmeeting_pdf2swf).' -q -s insertstop -s filloverlap '.escapeshellarg($CFG->dataroot.$inputfile).' -o '.escapeshellarg($CFG->dataroot.$outputfile));
                                                            }
                                                        } else {
                                                            exec(escapeshellcmd($CFG->fmsmeeting_pdf2swf).' -q -s insertstop -s filloverlap '.escapeshellarg($CFG->dataroot.$inputfile).' -o '.escapeshellarg($CFG->dataroot.$outputfile));
                                                        }
                                                        if (file_exists($CFG->dataroot.$outputfile)) {
                                                            $flashslide = $CFG->wwwroot.'/file.php'.$connector.$outputfile;
                                                        }
                                                    }
                                                }
                                            }
                                        break;
                                    }
                                }
                            }
                            if (!empty($flashslide)) {
                                $fmsmeeting->alltext .= "\t\t";

                                $fmsmeeting->alltext .= '<slide href="'.$flashslide.'" src="'.$slide.'" title="'.substr(basename($slide),0,strrpos(basename($slide),'.'))."\" />\n";
                            }
                        }
                    }
                    $fmsmeeting->alltext .= "\t</presentation>\n";
                } else {
                    unset($fmsmeeting->slides);
                }
            }
            unset($fmsmeeting->slideshow);
            if (isset($fmsmeeting->slideshow_coop)) {
                unset($fmsmeeting->slideshow_coop);
            }
            if (isset($fmsmeeting->slideshow_foreground)) {
                unset($fmsmeeting->slideshow_foreground);
            }
        }
    }
    
}

?>
