<?php

function fmsmeeting_add_instance($fmsmeeting) {
    fmsmeeting_postprocess($fmsmeeting);

    $fmsmeeting->timemodified = time();

    return insert_record('fmsmeeting', $fmsmeeting);

}

function fmsmeeting_update_instance($fmsmeeting) {
    fmsmeeting_postprocess($fmsmeeting);

    $fmsmeeting->id = $fmsmeeting->instance;
    $fmsmeeting->timemodified = time();

    return update_record('fmsmeeting', $fmsmeeting);
}

function fmsmeeting_delete_instance($fmsmeetingid) {

    $result = true;
    if (! delete_records('fmsmeeting', 'id', $fmsmeetingid)) {
        $result = false;
    }

    return $result;
}


function fmsmeeting_postprocess(&$fmsmeeting) {
    global $CFG;
    require_once($CFG->dirroot.'/mod/fmsmeeting/locallib.php');

    unset($fmsmeeting->slideshowlocation);

    if (empty($fmsmeeting->logo)) {
        $fmsmeeting->logo = $CFG->wwwroot.'/mod/fmsmeeting/logo.jpg';
    }

    $host = $CFG->fmsmeeting_serverhost;
    $port = $CFG->fmsmeeting_serverport;
    
    $fmsmeeting->alltext = '<connection host="HOST#" port="PORT#" application="fmsmeeting" instance="ROOM#" logo="'.$fmsmeeting->logo.
                           '" title="'.htmlentities(strip_tags($fmsmeeting->name))."\">\n";
    unset($fmsmeeting->logo);

    if ($fmsmeeting->type != 'custom') {
        if ($presetattributes = fmsmeeting_getpreset($fmsmeeting->type)) {
            foreach ($presetattributes as $attribute) {
                $fmsmeeting->$attribute = 1;
            }
        }
    }

    if ($components = fmsmeeting_getcomponents()) {
        foreach($components as $component) {
            if (isset($fmsmeeting->$component) && ($fmsmeeting->$component == 1)) {
                require_once($CFG->dirroot.'/mod/fmsmeeting/components/'.$component.'.php');

                $componentclass = 'fmsmeeting_'.$component;

                $comp = new $componentclass;

                $comp->_postprocess(&$fmsmeeting); 
            }
        }
    }

    $fmsmeeting->alltext .= "</connection>\n";
}

?>
