<?php

if (!isset($CFG->fmsmeeting_serverhost)) {
    set_config('fmsmeeting_serverhost','localhost');
}
if (!isset($CFG->fmsmeeting_serverport)) {
    set_config('fmsmeeting_serverport',1935);
}
if (!isset($CFG->fmsmeeting_roomprefix)) {
    set_config('fmsmeeting_roomprefix','');
}
if (!isset($CFG->fmsmeeting_customenabled)) {
    set_config('fmsmeeting_customenabled',0);
}
if (!isset($CFG->fmsmeeting_openoffice)) {
    set_config('fmsmeeting_openoffice','');
}
if (!isset($CFG->fmsmeeting_gif2swf)) {
    set_config('fmsmeeting_gif2swf','');
}
if (!isset($CFG->fmsmeeting_png2swf)) {
    set_config('fmsmeeting_png2swf','');
}
if (!isset($CFG->fmsmeeting_pdf2swf)) {
    set_config('fmsmeeting_pdf2swf','');
}

function fmsmeeting_gettypes() {
    global $CFG;
    
    $types = array();
    $types['meeting'] = get_string('meeting','fmsmeeting');
    $types['lesson'] = get_string('lesson','fmsmeeting');
    $types['broadcast'] = get_string('broadcast','fmsmeeting');
    $types['videoconference'] = get_string('videoconference','fmsmeeting');

    // FMS Meeting types
    if (isset($CFG->fmsmeeting_types) && (!empty($CFG->fmsmeeting_types))) {
        foreach ($CFG->fmsmeeting_types as $type) {
            $types[$type] = get_string($type,'fmsmeeting');
        }
    }

    // FMS Meeting custom settings
    if (isset($CFG->fmsmeeting_customenabled) && (!empty($CFG->fmsmeeting_customenabled))) {
        $types['custom'] = get_string('custom','fmsmeeting');
    }

    return $types;
}

function fmsmeeting_getpreset($preset) {
   
    $components = array();
    
    if ($preset == 'meeting') {
        $components = array('whiteboard',
                       'whiteboard_coop',
                       'whiteboard_trasparent',
                       'slideshow',
                       'slideshow_coop',
                       'slideshow_foreground',
                       'audiovideo',
                       'audiovideo_zoom',
                       'audiovideo_curtain',
                       'chat',
                       'chat_coop',
                       'people',
                       'cursor',
                       'cursor_name');
    } else if ($preset == 'lesson') {
        $components = array('whiteboard',
                       'whiteboard_trasparent',
                       'slideshow',
                       'slideshow_foreground',
                       'audiovideo',
                       'audiovideo_zoom',
                       'audiovideo_curtain',
                       'chat',
                       'chat_coop',
                       'people',
                       'cursor');
    } else if ($preset == 'broadcast') {
        $components = array('whiteboard',
                       'whiteboard_trasparent',
                       'slideshow',
                       'slideshow_foreground',
                       'audiovideo',
                       'audiovideo_hidestudents',
                       'cursor');
    } else if ($preset == 'videoconference') {
        $components = array('audiovideo',
                       'audiovideo_zoom',
                       'chat',
                       'chat_coop',
                       'people');
    }
    return $components;
}

function fmsmeeting_getcomponents() {
    global $CFG;

    $components = array();
    if ($componentfiles = fmsmeeting_scandir($CFG->dirroot.'/mod/fmsmeeting/components')) {

        foreach ($componentfiles as $componentfile) {
            if ((substr($componentfile,0,1) != '.') && eregi('\.([a-z0-9]+)$', $componentfile, $match)) {
                $extension = strtolower($match[1]);
                if ($extension == 'php') {
                    $components[] = substr($componentfile,0,-4);
                } 
            }
        }

    }
    return $components;
}

/**
* Given a diretory path returns the file list
*
* @param string $directory
* @return array
*/
function fmsmeeting_scandir($directory) {
    if (is_dir($directory)) {
        if (version_compare(phpversion(),'5.0.0','>=')) {
            return scandir($directory);
        } else {
            $files = array();
            if ($dh = opendir($directory)) {
                while (($file = readdir($dh)) !== false) {
                   $files[] = $file;
                }       
                closedir($dh);
            }       
            return $files; 
        }
    }
}

class fmsmeeting_component {

    var $name = '';

    var $attributes = array();

    function custom(&$mform) {
        if (!empty($this->name)) {
            // Slideshow settings
            $componentgroup = $this->name.'grp';
            $$componentgroup = array();
            $componentgrp = $$componentgroup;
            $componentgrp[] = &$mform->createElement('checkbox', $this->name, null, get_string('enable'));

            if (!empty($this->attributes)) {
                foreach ($this->attributes as $attribute) {
                   $componentgrp[] = &$mform->createElement('checkbox', $attribute, null, get_string($attribute, 'fmsmeeting'));
                }
            }
            $mform->addGroup($componentgrp, $componentgroup, get_string($this->name, 'fmsmeeting'), '<br />', false);
    
            $mform->setAdvanced($componentgroup);

            $mform->disabledIf($componentgroup, 'type', 'neq', 'custom');
        }
    }
    
    function config() {
      $config = '';
    
      return $config;
    }
    
    function mod_form(&$mform) {
    }

    function _preprocess(&$default_values,$fmsmeetingxml) {
        $component = $this->name;

        if (isset($fmsmeetingxml['connection']['#'][$component])) {
            if (!empty($fmsmeetingxml['connection']['#'][$component][0]['@'])) {
                $default_values[$component] = 1;
                $attributes = $fmsmeetingxml['connection']['#'][$component][0]['@'];
                foreach ($attributes as $attribute => $value) {
                    if ($value == 'true') {
                        $default_values[$component.'_'.$attribute] = 1;
                    }
                }
            }
        }
    }

    function _postprocess(&$formdata) {
    }
}

?>
