<?php
require_once ($CFG->dirroot.'/course/moodleform_mod.php');
require_once($CFG->dirroot.'/mod/fmsmeeting/locallib.php');

class mod_fmsmeeting_mod_form extends moodleform_mod {

    function definition() {

        global $CFG, $COURSE;
        $mform    =& $this->_form;

//-------------------------------------------------------------------------------
        $mform->addElement('header', 'general', get_string('general', 'form'));

// Name
        $mform->addElement('text', 'name', get_string('name'));
        $mform->setType('name', PARAM_TEXT);
        $mform->addRule('name', null, 'required', null, 'client');

// Summary
        $mform->addElement('htmleditor', 'summary', get_string('summary'));
        $mform->setType('summary', PARAM_RAW);
        $mform->setHelpButton('summary', array('writing', 'questions', 'richtext'), false, 'editorhelpbutton');

//-------------------------------------------------------------------------------
// Other Settings
        $mform->addElement('header', 'othersettings', get_string('othersettings', 'form'));

// FMS Meeting Type
        require_once($CFG->dirroot.'/mod/fmsmeeting/locallib.php');
        $fmsmeetingtypes = fmsmeeting_gettypes();
        $mform->addElement('select', 'type', get_string('type', 'fmsmeeting'), $fmsmeetingtypes);
        $mform->setHelpButton('type', array('type',get_string('type', 'fmsmeeting'),'fmsmeeting'));
        //$mform->addRule('type', get_string('required'), 'required', null, 'client');
        //$mform->setDefault('type', 'meeting');

// Logo Chooser
        $mform->addElement('choosecoursefile','logo', get_string('logo','fmsmeeting'));
        $mform->setAdvanced('logo');

        if ($components = fmsmeeting_getcomponents()) {
            foreach ($components as $component) {
                require_once($CFG->dirroot.'/mod/fmsmeeting/components/'.$component.'.php');
                
                $componentclass = 'fmsmeeting_'.$component;
    
                $comp = new $componentclass;
                
                $comp->mod_form(&$mform); 
            }
        }

// FMS Meeting custom settings
        if (isset($CFG->fmsmeeting_customenabled) && !empty($CFG->fmsmeeting_customenabled)) {
            $mform->addElement('header', 'customsettings', get_string('customsettings', 'fmsmeeting'));
            if ($components = fmsmeeting_getcomponents()) {
                foreach ($components as $component) {
                    require_once($CFG->dirroot.'/mod/fmsmeeting/components/'.$component.'.php');
                    
                    $componentclass = 'fmsmeeting_'.$component;
        
                    $comp = new $componentclass;
                    
                    $comp->custom(&$mform); 
                }
            }
        }
//-------------------------------------------------------------------------------
        $this->standard_coursemodule_elements();
//-------------------------------------------------------------------------------
        // buttons
        $this->add_action_buttons();
    }

    function data_preprocessing(&$default_values) {
        global $CFG;

        if (!empty($default_values['instance'])) {
            require_once($CFG->dirroot.'/mod/fmsmeeting/locallib.php');
    
            require_once($CFG->libdir.'/xmlize.php');
            $fmsmeetingxml = xmlize($default_values['alltext']);
    
            $default_values['logo'] = ($fmsmeetingxml['connection']['@']['logo']!=$CFG->wwwroot.'/mod/fmsmeeting/logo.jpg')?$fmsmeetingxml['connection']['@']['logo']:''; 
    
            if ($components = fmsmeeting_getcomponents()) {
                foreach ($components as $component) {
                    require_once($CFG->dirroot.'/mod/fmsmeeting/components/'.$component.'.php');
                        
                    $componentclass = 'fmsmeeting_'.$component;
        
                    $comp = new $componentclass;
                    
                    $comp->_preprocess(&$default_values,$fmsmeetingxml); 
                }
            }
        }
    }

    function validation($data) {
        return true;
    }
}
