<?php //$Id: restorelib.php,v 1.24.6.2 2007/04/22 22:05:19 stronk7 Exp $
    //This php script contains all the stuff to backup/restore
    //fmsmeeting mods

    //This is the "graphical" structure of the fmsmeeting mod:
    //
    //                     fmsmeeting                                      
    //                 (CL,pk->id,files)
    //
    // Meaning: pk->primary key field of the table
    //          fk->foreign key to link with parent
    //          nt->nested field (recursive data)
    //          CL->course level info
    //          UL->user level info
    //          files->table may have files)
    //
    //-----------------------------------------------------------

    //This function executes all the restore procedure about this mod
    function fmsmeeting_restore_mods($mod,$restore) {

        global $CFG;

        $status = true;

        //Get record from backup_ids
        $data = backup_getid($restore->backup_unique_code,$mod->modtype,$mod->id);

        if ($data) {
            //Now get completed xmlized object
            $info = $data->info;
            //traverse_xmlize($info);                                                                     //Debug
            //print_object ($GLOBALS['traverse_array']);                                                  //Debug
            //$GLOBALS['traverse_array']="";                                                              //Debug
          
            //Now, build the FMSMEETING record structure
            $fmsmeeting->course = $restore->course_id;
            $fmsmeeting->name = backup_todb($info['MOD']['#']['NAME']['0']['#']);
            $fmsmeeting->summary = backup_todb($info['MOD']['#']['SUMMARY']['0']['#']);
            $fmsmeeting->type = backup_todb($info['MOD']['#']['TYPE']['0']['#']);
            $fmsmeeting->alltext = backup_todb($info['MOD']['#']['ALLTEXT']['0']['#']);
            $fmsmeeting->timemodified = $info['MOD']['#']['TIMEMODIFIED']['0']['#'];

            //The structure is equal to the db, so insert the fmsmeeting
            $newid = insert_record ("fmsmeeting",$fmsmeeting);

            //Do some output     
            if (!defined('RESTORE_SILENTLY')) {
                echo "<li>".get_string("modulename","fmsmeeting")." \"".format_string(stripslashes($fmsmeeting->name),true)."\"</li>";
            }
            backup_flush(300);

            if ($newid) {
                //We have the newid, update backup_ids
                backup_putid($restore->backup_unique_code,$mod->modtype,
                             $mod->id, $newid);

                fmsmeeting_restore_files($mod->id,$newid,$fmsmeeting,$restore);
            } else {
                $status = false;
            }
        } else {
            $status = false;
        }

        return $status;
    }

    //Return a content decoded to support interactivities linking. Every module
    //should have its own. They are called automatically from
    //fmsmeeting_decode_content_links_caller() function in each module
    //in the restore process
    function fmsmeeting_decode_content_links ($content,$restore) {
            
        global $CFG;
            
        $result = $content;
                
        //Link to the list of fmsmeetings
                
        $searchstring='/\$@(FMSMEETINGINDEX)\*([0-9]+)@\$/';
        //We look for it
        preg_match_all($searchstring,$content,$foundset);
        //If found, then we are going to look for its new id (in backup tables)
        if ($foundset[0]) {
            //print_object($foundset);                                     //Debug
            //Iterate over foundset[2]. They are the old_ids
            foreach($foundset[2] as $old_id) {
                //We get the needed variables here (course id)
                $rec = backup_getid($restore->backup_unique_code,"course",$old_id);
                //Personalize the searchstring
                $searchstring='/\$@(FMSMEETINGINDEX)\*('.$old_id.')@\$/';
                //If it is a link to this course, update the link to its new location
                if (!empty($rec->new_id)) {
                    //Now replace it
                    $result= preg_replace($searchstring,$CFG->wwwroot.'/mod/fmsmeeting/index.php?id='.$rec->new_id,$result);
                } else { 
                    //It's a foreign link so leave it as original
                    $result= preg_replace($searchstring,$restore->original_wwwroot.'/mod/fmsmeeting/index.php?id='.$old_id,$result);
                }
            }
        }

        //Link to fmsmeeting view by moduleid

        $searchstring='/\$@(FMSMEETINGVIEWBYID)\*([0-9]+)@\$/';
        //We look for it
        preg_match_all($searchstring,$result,$foundset);
        //If found, then we are going to look for its new id (in backup tables)
        if ($foundset[0]) {
            //print_object($foundset);                                     //Debug
            //Iterate over foundset[2]. They are the old_ids
            foreach($foundset[2] as $old_id) {
                //We get the needed variables here (course_modules id)
                $rec = backup_getid($restore->backup_unique_code,"course_modules",$old_id);
                //Personalize the searchstring
                $searchstring='/\$@(FMSMEETINGVIEWBYID)\*('.$old_id.')@\$/';
                //If it is a link to this course, update the link to its new location
                if (!empty($rec->new_id)) {
                    //Now replace it
                    $result= preg_replace($searchstring,$CFG->wwwroot.'/mod/fmsmeeting/view.php?id='.$rec->new_id,$result);
                } else {
                    //It's a foreign link so leave it as original
                    $result= preg_replace($searchstring,$restore->original_wwwroot.'/mod/fmsmeeting/view.php?id='.$old_id,$result);
                }
            }
        }

        //Link to fmsmeeting view by fmsmeetingid

        $searchstring='/\$@(FMSMEETINGVIEWBYR)\*([0-9]+)@\$/';
        //We look for it
        preg_match_all($searchstring,$result,$foundset);
        //If found, then we are going to look for its new id (in backup tables)
        if ($foundset[0]) {
            //print_object($foundset);                                     //Debug
            //Iterate over foundset[2]. They are the old_ids
            foreach($foundset[2] as $old_id) {
                //We get the needed variables here (forum id)
                $rec = backup_getid($restore->backup_unique_code,"fmsmeeting",$old_id);
                //Personalize the searchstring
                $searchstring='/\$@(FMSMEETINGVIEWBYR)\*('.$old_id.')@\$/';
                //If it is a link to this course, update the link to its new location
                if($rec->new_id) {
                    //Now replace it
                    $result= preg_replace($searchstring,$CFG->wwwroot.'/mod/fmsmeeting/view.php?r='.$rec->new_id,$result);
                } else {
                    //It's a foreign link so leave it as original
                    $result= preg_replace($searchstring,$restore->original_wwwroot.'/mod/fmsmeeting/view.php?r='.$old_id,$result);
                }
            }
        }

        return $result;
    }

    //This function makes all the necessary calls to xxxx_decode_content_links()
    //function in each module, passing them the desired contents to be decoded
    //from backup format to destination site/course in order to mantain inter-activities
    //working in the backup/restore process. It's called from restore_decode_content_links()
    //function in restore process
    function fmsmeeting_decode_content_links_caller($restore) {
        global $CFG;
        $status = true;

        if ($fmsmeetings = get_records_sql ("SELECT r.id, r.alltext, r.summary
                                   FROM {$CFG->prefix}fmsmeeting r
                                   WHERE r.course = $restore->course_id")) {

            $i = 0;   //Counter to send some output to the browser to avoid timeouts
            foreach ($fmsmeetings as $fmsmeeting) {
                //Increment counter
                $i++;
                $content1 = $fmsmeeting->alltext;
                $content2 = $fmsmeeting->summary;
                $result1 = restore_decode_content_links_worker($content1,$restore);
                $result2 = restore_decode_content_links_worker($content2,$restore);

                if ($result1 != $content1 || $result2 != $content2) {
                    //Update record
                    $fmsmeeting->alltext = addslashes($result1);
                    $fmsmeeting->summary = addslashes($result2);
                    $status = update_record("fmsmeeting",$fmsmeeting);
                    if (debugging()) {
                        if (!defined('RESTORE_SILENTLY')) {
                            echo '<br /><hr />'.s($content1).'<br />changed to<br />'.s($result1).'<hr /><br />';
                            echo '<br /><hr />'.s($content2).'<br />changed to<br />'.s($result2).'<hr /><br />';
                        }
                    }
                }
                //Do some output
                if (($i+1) % 5 == 0) {
                    if (!defined('RESTORE_SILENTLY')) {
                        echo ".";
                        if (($i+1) % 100 == 0) {
                            echo "<br />";
                        }
                    }
                    backup_flush(300);
                }
            }
        }
        return $status;
    }


    //This function returns a log record with all the necessay transformations
    //done. It's used by restore_log_module() to restore modules log.
    function fmsmeeting_restore_logs($restore,$log) {
                    
        $status = false;
                    
        //Depending of the action, we recode different things
        switch ($log->action) {
        case "add":
            if ($log->cmid) {
                //Get the new_id of the module (to recode the info field)
                $mod = backup_getid($restore->backup_unique_code,$log->module,$log->info);
                if ($mod) {
                    $log->url = "view.php?id=".$log->cmid;
                    $log->info = $mod->new_id;
                    $status = true;
                }
            }
            break;
        case "update":
            if ($log->cmid) {
                //Get the new_id of the module (to recode the info field)
                $mod = backup_getid($restore->backup_unique_code,$log->module,$log->info);
                if ($mod) {
                    $log->url = "view.php?id=".$log->cmid;
                    $log->info = $mod->new_id;
                    $status = true;
                }
            }
            break;
        case "view":
            if ($log->cmid) {
                //Get the new_id of the module (to recode the info field)
                $mod = backup_getid($restore->backup_unique_code,$log->module,$log->info);
                if ($mod) {
                    $log->url = "view.php?id=".$log->cmid;
                    $log->info = $mod->new_id;
                    $status = true;
                }
            }
            break;
        case "view all":
            $log->url = "index.php?id=".$log->course;
            $status = true;
            break;
        default:
            if (!defined('RESTORE_SILENTLY')) {
                echo "action (".$log->module."-".$log->action.") unknown. Not restored<br />";                 //Debug
            }
            break;
        }

        if ($status) {
            $status = $log;
        }
        return $status;
    }   

    function fmsmeeting_restore_files($oldid,$newid,$fmsmeeting,$restore) {
        global $CFG;

        $status = true;
        $status = check_dir_exists($CFG->dataroot."/".$restore->course_id,true);

        // we need to do anything in moddata/fmsmeeting

        // and now for moddata.
        $temp_path = $CFG->dataroot."/temp/backup/".$restore->backup_unique_code."/moddata/fmsmeeting";
        if (file_exists($temp_path)) { // there's something to back up, restore it.
            $new_path = $CFG->dataroot."/".$restore->course_id."/".$CFG->moddata;
            $status = $status && check_dir_exists($new_path,true);
            $new_path .= '/fmsmeeting';
            $status = $status && check_dir_exists($new_path,true);
            $status = $status && backup_copy_file($temp_path,$new_path);
        }
        return $status;
    }

?>
