<?php
/**
* Display the fmsmeeting
*
* Displays a fmsmeeting in a popup.
*
*/
    require_once("../../config.php");
    
    $id = optional_param('id', '', PARAM_INT);       // Course Module ID, or
    $a = optional_param('a', '', PARAM_INT);         // meeting ID

    if (!empty($id)) {
        if (! $cm = get_coursemodule_from_id('fmsmeeting', $id)) {
            error("Course Module ID was incorrect");
        }
        if (! $course = get_record("course", "id", $cm->course)) {
            error("Course is misconfigured");
        }
        if (! $fmsmeeting = get_record("fmsmeeting", "id", $cm->instance)) {
            error("Course module is incorrect");
        }
    } else if (!empty($a)) {
        if (! $fmsmeeting = get_record("fmsmeeting", "id", $a)) {
            error("Course module is incorrect");
        }
        if (! $course = get_record("course", "id", $fmsmeeting->course)) {
            error("Course is misconfigured");
        }
        if (! $cm = get_coursemodule_from_instance("fmsmeeting", $fmsmeeting->id, $course->id)) {
            error("Course Module ID was incorrect");
        }
    } else {
        error('A required parameter is missing');
    }

    require_login($course->id, false, $cm);

    $context = get_context_instance(CONTEXT_COURSE, $course->id);
    
    $pagetitle = strip_tags($course->shortname.': '.format_string($fmsmeeting->name));

    $strfmsmeeting = get_string('modulename','fmsmeeting');
    $strfmsmeetings = get_string('modulenameplural','fmsmeeting');

    if ($course->id != SITEID) {
        $navigation = "<a $CFG->frametarget onclick=\"this.target='$CFG->framename'\" href=\"$CFG->wwwroot/course/view.php?id={$course->id}\">{$course->shortname}</a> -> ".
                      "<a $CFG->frametarget onclick=\"this.target='$CFG->framename'\" href=\"index.php?id={$course->id}\">$strfmsmeetings</a> ->";
    } else {
        $navigation = "<a $CFG->frametarget onclick=\"this.target='$CFG->framename'\" href=\"index.php?id={$course->id}\">$strfmsmeetings</a> ->";
    }

    if (!$cm->visible and !has_capability('moodle/course:viewhiddenactivities', get_context_instance(CONTEXT_MODULE, $cm->id))) {
        $pagetitle = strip_tags($course->shortname.': '.$strfmsmeeting);
        print_header($pagetitle, $course->fullname, "$navigation $strfmsmeeting", "", "", true, '', navmenu($course, $cm));
        notice(get_string("activityiscurrentlyhidden"), "$CFG->wwwroot/course/view.php?id={$course->id}");
    }
    
    /// Set up some variables

    $inpopup = optional_param('inpopup', 0, PARAM_BOOL);

    $fullurl = $CFG->wwwroot.'/mod/fmsmeeting/fmsmeeting.swf';

    // Make a page and a pop-up window
    if (!$inpopup) {
        print_header($pagetitle, $course->fullname, "$navigation ".format_string($fmsmeeting->name), "", "", true, update_module_button($cm->id, $course->id, $strfmsmeeting), navmenu($course, $cm));
    
        $popup = 'width=875,height=800,resizable,scrollbars';
    
        echo "\n<script type=\"text/javascript\">";
        echo "\n<!--\n";
        echo "openpopup('/mod/fmsmeeting/view.php?inpopup=true&id={$cm->id}','meeting{$fmsmeeting->id}','{$popup}');\n";
        echo "\n-->\n";
        echo '</script>';
    
        if (trim(strip_tags($fmsmeeting->summary))) {
            $formatoptions = new object();
            $formatoptions->noclean = true;
            print_simple_box(format_text($fmsmeeting->summary, FORMAT_MOODLE, $formatoptions), "center");
        }
    
        $link = "<a href=\"$CFG->wwwroot/mod/fmsmeeting/view.php?inpopup=true&amp;id={$cm->id}\" onclick=\"this.target='meeting{$fmsmeeting->id}'; return openpopup('/mod/fmsmeeting/view.php?inpopup=true&amp;id={$cm->id}', 'meeting{$fmsmeeting->id}','{$popup}');\">".format_string($fmsmeeting->name,true)."</a>";
    
        echo '<div class="popupnotice">';
        print_string('popupmeeting', 'fmsmeeting');
        echo '<br />';
        print_string('popupmeetinglink', 'fmsmeeting', $link);
        echo '</div>';
    
        print_footer($course);
        exit;
    }

    /// Display the actual meeting

    if ($inpopup) {
        print_header($pagetitle);

        /// We can only get here once per meeting, so add an entry to the log

        add_to_log($course->id, "fmsmeeting", "view", "view.php?id={$cm->id}", $fmsmeeting->id, $cm->id);

    } else {
        print_header($pagetitle, $course->fullname, "$navigation ".format_string($fmsmeeting->name,true), "", "", true, update_module_button($cm->id, $course->id, $strfmsmeeting), navmenu($course, $cm, "self"));

    }

    $c = 'xmlfile='.$CFG->wwwroot.'/mod/fmsmeeting/fmsmeeting.php?id='.$cm->id.'-sesskey='.$USER->sesskey;
    echo '<div class="meetingcontent">'."\n";
    echo '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"'."\n";
    echo '        codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" '."\n";
    echo '        width="850" height="775" id="meeting" >'."\n";
    echo '<param name="movie" value="'.$fullurl.'" />'."\n";
    echo '<param name="quality" value="high" />'."\n";
    echo '<param name="flashvars" value="'.$c.'" />'."\n";
    echo '<embed src="'.$fullurl.'" '."\n";
    echo ' quality="high" width="850" height="775" name="meeting" '."\n";
    echo ' type="application/x-shockwave-flash" '."\n";
    echo ' flashvars="'.$c.'" '."\n";
    echo ' pluginspage="http://www.macromedia.com/go/getflashplayer">'."\n";
    echo '</embed>'."\n";
    echo '</object>'."\n";
    echo '</div>'."\n";


    if (!$inpopup) {
        print_spacer(20,20);
        print_footer($course);
    } else {
        echo '</div></div></body></html>';
    }

?>
